<?php
/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Controllers\Administrator;

use App\Exceptions\DefaultException;
use App\Http\Base\BaseController;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use App\Http\Services\LoginlogService;
use App\Http\Validators\LoginlogValidator;
use App\Http\Services\UsersService;

class LoginlogController extends BaseController
{
    protected $baseService;
    protected $validator;
    private $users;

    /**
     * Loginlog constructor.
     */
    public function __construct()
    {
        parent::__construct();
        $this->baseService = new LoginlogService();
        $this->validator = new LoginlogValidator();
        $this->users = new UsersService();

    }


    /**
     * @param Request $request
     * @return \Illuminate\Http\RedirectResponse
     * @throws DefaultException
     */
    public function store(Request $request)
    {
        $this->validator->beforeInsert($request->all());
        if ($this->validator->hasError())
            return $this->validator->validateView();
        DB::beginTransaction();
        try {
            $this->baseService->store($request->all());
            DB::commit();
            $this->sync();
            return redirect()->to("administrator/loginlog")->with("successMessages", "Data has been created");
        } catch (\Exception $e) {
            DB::rollBack();
            throw new DefaultException($e->getMessage());
        }
    }

    /**
     * @param Request $request
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function paging(Request $request)
    {
        $this->data["header"] = ["id" => "id"
            , "userId" => "userId"
            , "loginStartDate" => "loginStartDate"
            , "loginEndDate" => "loginEndDate"
        ];
        $this->data["criteria"] = ["id" => "id"
            , "userId" => "userId"
            , "loginStartDate" => "loginStartDate"
            , "loginEndDate" => "loginEndDate"
        ];
        $this->data["ordering"] = [
             "name:asc" => "Username &uarr;"
            , "name:desc" => "Username &darr;"
            , "loginStartDate:asc" => "Login &uarr;"
            , "loginStartDate:desc" => "Login &darr;"
            , "loginEndDate:asc" => "Logout &uarr;"
            , "loginEndDate:desc" => "Logout &darr;"
        ];
        $this->data["loginlogs"] = $this->baseService->paging($request);
        return view("modules.loginlog.loginlog_index", $this->data);
    }

    /**
     * @param $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function edit($id)
    {
        $this->data["userss"] = $this->users->index();
        $this->data["loginlog"] = $this->baseService->show($id);
        return view("modules.loginlog.loginlog_edit", $this->data);
    }


    /**
     * @param Request $request
     * @param $id
     * @return \Illuminate\Http\RedirectResponse
     * @throws DefaultException
     */
    public function update(Request $request, $id)
    {
        $this->validator->beforeUpdate($request->all(), $id);
        if ($this->validator->hasError())
            return $this->validator->validateView();
        DB::beginTransaction();
        try {
            $this->baseService->update($id, $request->all());
            DB::commit();
            $this->sync();
            return redirect()->to("administrator/loginlog")->with("successMessages", "Data has been updated");
        } catch (\Exception $e) {
            DB::rollBack();
            throw new DefaultException($e->getMessage());
        }
    }

    /**
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function create()
    {
        $this->data["userss"] = $this->users->index();
        return view("modules.loginlog.loginlog_create", $this->data);
    }

    /**
     * @param $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function show($id)
    {
        $this->data["userss"] = $this->users->index();
        $this->data["loginlog"] = $this->baseService->show($id);
        return view("modules.loginlog.loginlog_show", $this->data);
    }

    /**
     *  index function that get all data from database by default
     * @param $ids
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function destroy($ids)
    {
        $this->baseService->delete($ids);
        return redirect()->back()->with("successMessages", "Data has been deleted");
    }


}